{% macro form_builder(field, options = {}) -%}
    {% set type = widget_type(field) %}
    {% if 'input' in type %}
        {{ input(field, options) }}
    {% elif type == 'textarea' %}
        {{ textarea(field) }}    
    {% elif type == 'select' %}
        {{ select(field, options) }}
    {% else %}
        <p>{{ name(field) }} not implemented</p>
    {% endif %}
{%- endmacro %}
{% macro input(field, options) -%}
    {{ label(field) }}
    <div class="field {{ ('has-addons' if options.addons is defined) }}">
        <div class="control is-expanded {{ ('has-icons-right' if options.icon_right is defined or field.errors)
                ~ (' has-icons-left' if options.icon_left is defined)-}}">
            <input
                class="input {{ 'is-danger' if field.errors }}"
                type="{{ type(field) }}"
                name="{{ name(field) }}"
                id="{{ id(field) }}"
                value="{{ value(field) }}"
                {{ 'required' if is_required(field) == True }}
                {{ attrs(field) }}
            >
            {% if not field.errors and options.icon_left is defined %}
                <span class="icon is-small is-left">
                    <i class="fas {{ options.icon_left }}"></i>
                </span>
            {% endif %}

            {% if field.errors %}
                <span class="icon is-small is-right is-danger">
                    <i data-id="{{ id(field) }}" class="fas fa-exclamation-triangle"></i>
                </span>
            {% endif %}

            {% if options.icon_right is defined %}
                <span class="icon is-small is-left">
                    <i class="fas {{ options.icon_right }}"></i>
                </span>
            {% endif %}
        </div>

        {% if options.addons is defined %}
            <div class="control">
                <a data-id="{{ id(field) }}" class="button is-info">
                    <i data-id="{{ id(field) }}" class="fas {{ options.addons }}"></i>
                </a>
            </div>
        {% endif %}
    </div>
    {% if options.settings is defined %}
        {% if "password_strength" in options.settings %}
            {{ password_stength(field) }}
        {% endif %}
    {% endif %}
    {{ help(field) }}
    {{ errors(field) }}
{%- endmacro %}
{% macro textarea(field, options) -%}
    <div class="field">
        {{ label(field) }}
        <div class="control">
            <textarea
                    class="textarea {{ 'is-danger' if field.errors }}"
                    name="{{ name(field) }}"
                    id="{{ id(field) }}"
                    {{ 'required' if is_required(field) == True }}
                    {{ attrs(field) }}>
                {{- value(field) -}}
            </textarea>
        </div>
        {{ help(field) }}
        {{ errors(field) }}
    </div>
{%- endmacro %}

{% macro select(field, options) -%}
    {{ label(field) }}
    <div class="field">
        <div class="select" style="width: 30%;">
            <select
                name="{{ name(field) }}"
                id="{{ id(field) }}"
                style="width: 100%;"
            >
                {{ choices(field, options) }}
            </select>
        </div>
    </div>
    {{ help(field) }}
    {{ errors(field) }}
{%- endmacro %}

{% macro label(field) -%}
    <label class="label" for="{{ id(field) }}">{{ field.label }}</label>
{%- endmacro %}

{% macro choices(field, options) -%}
    <option value="">--Please choose an option--</option>
    {% for key, selectValue in field.field.widget.choices %}
        {% if not selectValue == options.user|string %}            
            <option {{ 'selected' if key|string == value(field) }} value="{{ key }}">{{ selectValue }}</option>
        {% endif %}
    {% endfor %}
{%- endmacro %}

{% macro help(field) -%}
    {% if field.help_text %}
        <article class="message is-info">
            <div class="message-body">
                {{ field.help_text | safe }}
            </div>
        </article>
    {% endif %}
{%- endmacro %}

{% macro password_stength(field) -%}
    <progress id="progress-bar-{{ id(field)}}" class="progress" value="0" max="100"></progress>
{%- endmacro %}

{% macro id(field) -%}
    {{ field.id_for_label }}
{%- endmacro %}

{% macro name(field) -%}
    {{ field.name }}
{%- endmacro %}

{% macro value(field) -%}
    {{ field.value() if field.value() != None else "" }}
{%- endmacro %}

{% macro errors(field) -%}
    {% if field.errors %}
        <article class="message is-danger">
            <div class="message-body">
                {{ field.errors }}
            </div>
        </article>
    {% endif %}
{%- endmacro %}

{% macro type(field) -%}
    {{ field.field.widget.input_type }}
{%- endmacro %}

{% macro attrs(field) -%}
    {% if field.field.widget is defined and
        field.field.widget.attrs is defined and
        field.field.widget.attrs | length > 0 %}
        {% for attr in field.field.widget.attrs %}{{ attr }}="{{ field.field.widget.attrs[attr] }}"{% endfor %}
    {% endif %}
{%- endmacro %}

{% macro widget_type(field) -%}
    {{ field|widget_type }}
{%- endmacro %}

{% macro is_required(field) -%}
    {{ field.required }}
{%- endmacro %}